Subject: Re: [netmod] draft-ietf-netmod-rfc6991-bis: Comment on node-instance-identifier

From: Schönwälder, Jürgen <[email-masked]>
Date: Mon, 4 Nov 2019 10:32:43 +0000

Hi,

this may be resolved by adding

     The special value '/' refers to the entire accessible tree.

to the description statement. Does this work for you?

/js

On Mon, Sep 30, 2019 at 03:17:25PM +0100, Robert Wilton wrote:
> Hi Juergen,
> 
> Should the "node-instance-identify" type specify how the path "/" is
> treated?
> 
> I noted that in rfc8341, the behavior for "/" is described in the leaf
> "path" description rather than in the type definition, but I was thinking
> that it might be better if this behaviour was specified as part of the
> typedef.
> 
> Snippet from RFC8341:
> 
>              case data-node {
>                leaf path {
>                  type node-instance-identifier;
>                  mandatory true;
>                  description
>                    "Data node instance-identifier associated with the
>                     data node, action, or notification controlled by
>                     this rule.
> 
>                     Configuration data or state data
>                     instance-identifiers start with a top-level
>                     data node.  A complete instance-identifier is
>                     required for this type of path value.
> 
>                     The special value '/' refers to all possible
>                     datastore contents.";
>                }
>              }
> 
> Thanks,
> Rob
> 

-- 
Juergen Schoenwaelder           Jacobs University Bremen gGmbH
Phone: +49 421 200 3587         Campus Ring 1 | 28759 Bremen | Germany
Fax:   +49 421 200 3103         <https://www.jacobs-university.de/>

---

From: "Rob Wilton (rwilton)" <[email-masked]>
Date: Mon, 4 Nov 2019 10:34:21 +0000

Hi Juergen,

Yes, that works for me.

Thanks,
Rob

-----Original Message-----
From: Schönwälder, Jürgen <[email-masked]> 
Sent: 04 November 2019 10:33
To: Rob Wilton (rwilton) <[email-masked]>
Cc: [email-masked]; [email-masked]
Subject: Re: draft-ietf-netmod-rfc6991-bis: Comment on node-instance-identifier

Hi,

/js

On Mon, Sep 30, 2019 at 03:17:25PM +0100, Robert Wilton wrote:
> "path" description rather than in the type definition, but I was 
> thinking that it might be better if this behaviour was specified as 
> part of the typedef.
> 
> Snippet from RFC8341:
> 
>              case data-node {
>                leaf path {

---

From: Per Hedeland <[email-masked]>
Date: Mon, 4 Nov 2019 13:19:47 +0100

> to the description statement. Does this work for you?

Hm, it seems to me that this would conflict with this part of the
description:

        A node-instance-identifier value is an
        unrestricted YANG instance-identifier expression.

        All the same rules as an instance-identifier apply,
        except that predicates for keys are optional.  If a key
        predicate is missing, then the node-instance-identifier
        represents all possible server instances for that key.

- since '/' is not a valid value for a YANG instance-identifier.
I.e. if '/' should be included in the typedef (seems reasonable to
me), the text for it probably needs to be "incorporated" in the text
above.

--Per

---

From: Schönwälder, Jürgen <[email-masked]>
Date: Mon, 4 Nov 2019 13:46:45 +0000

Hi,

what about this wording :

     [...]

      A node-instance-identifier value is an unrestricted
      YANG instance-identifier expression or the special
      value '/', which refers to the entire accessible tree.

     [...]

/js

---

From: Per Hedeland <[email-masked]>
Date: Mon, 4 Nov 2019 15:52:20 +0100

>        value '/', which refers to the entire accessible tree.

Yes, that should be "good enough" I think. Though when reading the
text from NACM for the umpteenth time, I got hung up on the word
"unrestricted" - doesn't that mean "require-instance true"?

 From 7950:

9.13.1.  Restrictions

    An instance-identifier can be restricted with the "require-instance"
    statement (Section 9.9.3).

9.9.3.  The "require-instance" Statement

    The "require-instance" statement, which is a substatement to the
    "type" statement, MAY be present if the type is "instance-identifier"
    or "leafref".  It takes as an argument the string "true" or "false".
    If this statement is not present, it defaults to "true".

Probably not worth worrying about...

--Per